accrue.analysis.pointer.analyses

## Class StickFirstCalledFrom

- java.lang.Object
- - accrue.analysis.pointer.analyses.HeapAbstractionFactory
  - - accrue.analysis.pointer.analyses.StickFirstMatches
    - - accrue.analysis.pointer.analyses.StickFirstCalledFrom

-     public class StickFirstCalledFrom
      extends StickFirstMatches

  Analysis that keeps the first N call sites where the file called from matches a particular prefix. Once the context stack is full, no more call sites are tracked, even if they match. This can be used together with a more general analysis, using `CrossProductAnalysis`, to gain distinguish calls to particular methods or packages. For example to calls from an application by using "myapplication.mypkg" or "myapplication.mypkg.MyClass" for the prefix.

- - ### Field Summary

    - ### Fields inherited from class accrue.analysis.pointer.analyses.StickFirstMatches

      `EMPTY_CONTEXT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `StickFirstCalledFrom(int sensitivity, java.lang.String prefixToTrack)` Create an analysis that tracks called from a particular prefix with the given context-call-stack depth, once that depth is reached the context is "stuck" and no more call sites are added.
    `StickFirstCalledFrom(java.lang.String prefixToTrack)` Create an analysis that tracks methods called from a particular prefix with the given context-call-stack depth, once that depth is reached the context is "stuck" and no more call sites are added.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `toString()`

    - ### Methods inherited from class accrue.analysis.pointer.analyses.StickFirstMatches

      `init, initialContextImpl, mergeImpl, recordImpl`

    - ### Methods inherited from class accrue.analysis.pointer.analyses.HeapAbstractionFactory

      `clearMemoization, fixContextForReferenceVariable, initialContext, memoize, memoize, merge, record`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### StickFirstCalledFrom

          public StickFirstCalledFrom(int sensitivity,
                              java.lang.String prefixToTrack)

      Create an analysis that tracks called from a particular prefix with the given context-call-stack depth, once that depth is reached the context is "stuck" and no more call sites are added.
      Parameters:
        `sensitivity` - depth of the call stack to keep track of
        `prefixToTrack` - Methods called from this prefix will be tracked up to the sensitivity, deeper than the sensitivity they will "stick" in the context.

    - #### StickFirstCalledFrom

          public StickFirstCalledFrom(java.lang.String prefixToTrack)

      Create an analysis that tracks methods called from a particular prefix with the given context-call-stack depth, once that depth is reached the context is "stuck" and no more call sites are added.
      Parameters:
        `prefixToTrack` - Methods called from this prefix will be tracked up to the sensitivity, deeper than the sensitivity they will "stick" in the context.

  - ### Method Detail

    - #### toString

          public java.lang.String toString()

      Specified by:
        `toString` in class `StickFirstMatches`